# AUTO GENERATED FILE - DO NOT EDIT

from dash.development.base_component import Component, _explicitize_args


class Menu(Component):
    """A Menu component.
Material-UI Menu.

Keyword arguments:
- children (a list of or a singular dash component, string or number; optional): Menu contents, normally `MenuItem`s.
- autoFocus (boolean; optional): If `true` (Default) will focus the `[role="menu"]` if no focusable child is found. Disabled
children are not focusable. If you set this prop to `false` focus will be placed
on the parent modal container. This has severe accessibility implications
and should only be considered if you manage focus otherwise.
- disableAutoFocusItem (boolean; optional): When opening the menu will not focus the active item but the `[role="menu"]`
unless `autoFocus` is also set to `false`. Not using the default means not
following WAI-ARIA authoring practices. Please be considerate about possible
accessibility implications.
- open (boolean; optional): If `true`, the menu is visible.
- variant (a value equal to: "menu", "selectedMenu"; optional): The variant to use. Use `menu` to prevent selected items from impacting the initial focus
and the vertical alignment relative to the anchor element.
- defaultChecked (boolean; optional)
- suppressContentEditableWarning (boolean; optional)
- suppressHydrationWarning (boolean; optional)
- accessKey (string; optional)
- className (string; optional)
- contentEditable (a value equal to: false, true, "true", "false", "inherit"; optional)
- contextMenu (string; optional)
- dir (string; optional)
- draggable (a value equal to: false, true, "true", "false"; optional)
- hidden (boolean; optional)
- id (string; optional)
- lang (string; optional)
- placeholder (string; optional)
- slot (string; optional)
- spellCheck (a value equal to: false, true, "true", "false"; optional)
- tabIndex (number; optional)
- title (string; optional)
- translate (a value equal to: "yes", "no"; optional)
- radioGroup (string; optional)
- role (string; optional)
- about (string; optional)
- datatype (string; optional)
- inlist (boolean | number | string | dict | list; optional)
- prefix (string; optional)
- property (string; optional)
- resource (string; optional)
- typeof (string; optional)
- vocab (string; optional)
- autoCapitalize (string; optional)
- autoCorrect (string; optional)
- autoSave (string; optional)
- color (string; optional)
- itemProp (string; optional)
- itemScope (boolean; optional)
- itemType (string; optional)
- itemID (string; optional)
- itemRef (string; optional)
- results (number; optional)
- security (string; optional)
- unselectable (a value equal to: "on", "off"; optional)
- inputMode (a value equal to: "none", "text", "tel", "url", "email", "numeric", "decimal", "search"; optional): Hints at the type of data that might be entered by the user while editing the element or its contents
- is (string; optional): Specify that a standard HTML element should behave like a defined custom built-in element
- elevation (number; optional): The elevation of the popover.
- closeAfterTransition (boolean; optional): When set to true the Modal waits until a nested Transition is completed before closing.
- disableAutoFocus (boolean; optional): If `true`, the modal will not automatically shift focus to itself when it opens, and
replace it to the last focused element when it closes.
This also works correctly with any modal children that have the `disableAutoFocus` prop.

Generally this should never be set to `true` as it makes the modal less
accessible to assistive technologies, like screen readers.
- disableEnforceFocus (boolean; optional): If `true`, the modal will not prevent focus from leaving the modal while open.

Generally this should never be set to `true` as it makes the modal less
accessible to assistive technologies, like screen readers.
- disableEscapeKeyDown (boolean; optional): If `true`, hitting escape will not fire `onClose`.
- disablePortal (boolean; optional): The `children` will be inside the DOM hierarchy of the parent component.
- disableRestoreFocus (boolean; optional): If `true`, the modal will not restore focus to previously focused element once
modal is hidden.
- disableScrollLock (boolean; optional): Disable the scroll lock behavior.
- hideBackdrop (boolean; optional): If `true`, the backdrop is not rendered.
- keepMounted (boolean; optional): Always keep the children in the DOM.
This prop can be useful in SEO situation or
when you want to maximize the responsiveness of the Modal.
- anchorReference (a value equal to: "none", "anchorEl", "anchorPosition"; optional): This determines which anchor prop to refer to to set
the position of the popover.
- marginThreshold (number; optional): Specifies how close to the edge of the window the popover can appear.
- classes (dict; optional): Override or extend the styles applied to the component.
- style (dict; optional)
- n_clicks (number; default 0): An integer that represents the number of times that this element has been clicked on."""
    @_explicitize_args
    def __init__(self, children=None, autoFocus=Component.UNDEFINED, disableAutoFocusItem=Component.UNDEFINED, open=Component.UNDEFINED, variant=Component.UNDEFINED, defaultChecked=Component.UNDEFINED, suppressContentEditableWarning=Component.UNDEFINED, suppressHydrationWarning=Component.UNDEFINED, accessKey=Component.UNDEFINED, className=Component.UNDEFINED, contentEditable=Component.UNDEFINED, contextMenu=Component.UNDEFINED, dir=Component.UNDEFINED, draggable=Component.UNDEFINED, hidden=Component.UNDEFINED, id=Component.UNDEFINED, lang=Component.UNDEFINED, placeholder=Component.UNDEFINED, slot=Component.UNDEFINED, spellCheck=Component.UNDEFINED, tabIndex=Component.UNDEFINED, title=Component.UNDEFINED, translate=Component.UNDEFINED, radioGroup=Component.UNDEFINED, role=Component.UNDEFINED, about=Component.UNDEFINED, datatype=Component.UNDEFINED, inlist=Component.UNDEFINED, prefix=Component.UNDEFINED, property=Component.UNDEFINED, resource=Component.UNDEFINED, typeof=Component.UNDEFINED, vocab=Component.UNDEFINED, autoCapitalize=Component.UNDEFINED, autoCorrect=Component.UNDEFINED, autoSave=Component.UNDEFINED, color=Component.UNDEFINED, itemProp=Component.UNDEFINED, itemScope=Component.UNDEFINED, itemType=Component.UNDEFINED, itemID=Component.UNDEFINED, itemRef=Component.UNDEFINED, results=Component.UNDEFINED, security=Component.UNDEFINED, unselectable=Component.UNDEFINED, inputMode=Component.UNDEFINED, elevation=Component.UNDEFINED, closeAfterTransition=Component.UNDEFINED, disableAutoFocus=Component.UNDEFINED, disableEnforceFocus=Component.UNDEFINED, disableEscapeKeyDown=Component.UNDEFINED, disablePortal=Component.UNDEFINED, disableRestoreFocus=Component.UNDEFINED, disableScrollLock=Component.UNDEFINED, hideBackdrop=Component.UNDEFINED, keepMounted=Component.UNDEFINED, anchorReference=Component.UNDEFINED, marginThreshold=Component.UNDEFINED, classes=Component.UNDEFINED, style=Component.UNDEFINED, n_clicks=Component.UNDEFINED, **kwargs):
        self._prop_names = ['children', 'autoFocus', 'disableAutoFocusItem', 'open', 'variant', 'defaultChecked', 'suppressContentEditableWarning', 'suppressHydrationWarning', 'accessKey', 'className', 'contentEditable', 'contextMenu', 'dir', 'draggable', 'hidden', 'id', 'lang', 'placeholder', 'slot', 'spellCheck', 'tabIndex', 'title', 'translate', 'radioGroup', 'role', 'about', 'datatype', 'inlist', 'prefix', 'property', 'resource', 'typeof', 'vocab', 'autoCapitalize', 'autoCorrect', 'autoSave', 'color', 'itemProp', 'itemScope', 'itemType', 'itemID', 'itemRef', 'results', 'security', 'unselectable', 'inputMode', 'is', 'elevation', 'closeAfterTransition', 'disableAutoFocus', 'disableEnforceFocus', 'disableEscapeKeyDown', 'disablePortal', 'disableRestoreFocus', 'disableScrollLock', 'hideBackdrop', 'keepMounted', 'anchorReference', 'marginThreshold', 'classes', 'style', 'n_clicks']
        self._type = 'Menu'
        self._namespace = 'materialdashboard'
        self._valid_wildcard_attributes =            []
        self.available_properties = ['children', 'autoFocus', 'disableAutoFocusItem', 'open', 'variant', 'defaultChecked', 'suppressContentEditableWarning', 'suppressHydrationWarning', 'accessKey', 'className', 'contentEditable', 'contextMenu', 'dir', 'draggable', 'hidden', 'id', 'lang', 'placeholder', 'slot', 'spellCheck', 'tabIndex', 'title', 'translate', 'radioGroup', 'role', 'about', 'datatype', 'inlist', 'prefix', 'property', 'resource', 'typeof', 'vocab', 'autoCapitalize', 'autoCorrect', 'autoSave', 'color', 'itemProp', 'itemScope', 'itemType', 'itemID', 'itemRef', 'results', 'security', 'unselectable', 'inputMode', 'is', 'elevation', 'closeAfterTransition', 'disableAutoFocus', 'disableEnforceFocus', 'disableEscapeKeyDown', 'disablePortal', 'disableRestoreFocus', 'disableScrollLock', 'hideBackdrop', 'keepMounted', 'anchorReference', 'marginThreshold', 'classes', 'style', 'n_clicks']
        self.available_wildcard_properties =            []

        _explicit_args = kwargs.pop('_explicit_args')
        _locals = locals()
        _locals.update(kwargs)  # For wildcard attrs
        args = {k: _locals[k] for k in _explicit_args if k != 'children'}

        for k in []:
            if k not in args:
                raise TypeError(
                    'Required argument `' + k + '` was not specified.')
        super(Menu, self).__init__(children=children, **args)
